<?php

class ClassLoader {

	protected $classes = array();

	function load($dirs) {
		foreach ($dirs as $dir) {
			$this->load_from_dir($dir);
		}
	}

	protected function load_from_dir($dir) {
		$dir_iter = new RecursiveDirectoryIterator($dir);
		$iter = new RecursiveIteratorIterator($dir_iter);
		$regex = new RegexIterator($iter, '/^.+\.php$/i', RecursiveRegexIterator::GET_MATCH);
		$regex->next();
		while ($regex->valid()) {
			$file = new SplFileInfo($regex->current()[0]);
			$this->classes[$file->getBasename('.php')] = $file->getRealPath();
			$regex->next();
		}
	}

	function get($class_name) {
		$file = $this->classes[$class_name];
		if (!$file) {
			throw new MissingException($class_name);
		}
		return $file;
	}
}